//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// UnmanagedFault.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "UnmanagedFault.h"
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

UNMANAGEDFAULT_API int Fail(void)
{
	throw "This is an error";
	return 42;
}

class custom_exception : public std::exception
{
public:
	explicit custom_exception(const std::string& _message) : message(_message)
	{
	}

	virtual ~custom_exception()
	{
	}

	virtual const char *what()
	{
		return (message.c_str());
	}

private:
	// The message
	std::string message;
};

UNMANAGEDFAULT_API int Custom(void)
{
	throw custom_exception("This is a custome exception");
	return 42;
}
UNMANAGEDFAULT_API int DivideByZero(void)
{
	int a = 0;
	int b = 1;
	return b/a;
}
UNMANAGEDFAULT_API int MemoryAccess(void)
{
	int *pint = 0;
	pint[5] = 10;
	return 0;
}
